/****************************************************************************

 COPYRIGHT 1996 IBM Corporation / Samplex Technologies, Inc.

 FILE NAME:     parse.h

 DESCRIPTION:   Parser public interface

 LAST MODIFIED: [10-24-96 23:40:10]

 $Revision:$
   
****************************************************************************/


#define AMT_LEN         16      /* Amount token max length */
#define TPC_LEN         18      /* Transaction and Processing Code max len */
#define CMC7BANK_LEN    12      /* Bank max len for CMC7 checks */
#define CSN_LEN         20      /* Check Sequence Number max length */
#define ACC_LEN         19      /* Account number max length */
#define TRN_LEN         9       /* Routine Symbol ABA number mac length */
#define EPC_LEN         1       /* External Processing Code max length */
#define ONUS_LEN        25      /* OnUs field max length */
#define AXON_LEN        21      /* Auxiliary OnUs field max length*/

#define MAX_FIELD_LEN   ONUS_LEN

typedef struct
    {
    char    status;
    char    exception_state;
    char    unrecognized_symbols;
    char    amount_status;
    char    amount[AMT_LEN+1];
    char    account_status;
    char    account[ACC_LEN+4];     /* extra space for SPACEs */
    char    tpc_status;
    char    tpc[TPC_LEN+1];
    char    csn_status;
    char    csn[CSN_LEN+1];
    char    transit_status;
    char    transit[max(TRN_LEN, CMC7BANK_LEN)+1];
    char    epc_status;
    char    epc[EPC_LEN+1];
    char    onus_status;
    char    onus[ONUS_LEN+4];       /* extra space for SPACEs */
    char    auxonus_status;
    char    auxonus[AXON_LEN+1];
    } PARSER_STATUS;

/*
**  Values for exception_status
*/
#define EX_NORMAL   0               /* No Exception used */
#define EX_USED     1               /* Exception item used */
#define EX_OPEN_ERR 2               /* Error opening exception file */
#define EX_INVALID  3               /* Error in an exception record */

/*
**  Values for field status
*/
#define FIELD_OK        0
#define FIELD_INVALID   1
#define FIELD_MISSING   2
#define FIELD_TOOLONG   3
#define FIELD_UNRECOG   4
#define FIELD_NOTERM    5

/*
**  Overall status values
*/
#define PASS            0
#define FAIL            1


/*
**  Interface prototype
*/
PARSER_STATUS   *ParseMicr (char *RawMicrLine);
